#include "..\BSOD System\BSOD.h"
#include "..\Interupt Service System\IDT.h"
#include "..\Interupt Service System\exception.h"
#include "..\Interupt Service System\pic.h"
#include "..\Shared\iflag.h"

void kmain()
{
	// some vars for the test code
	int i,j;

	// Initialize all parts of kernel

	// IDT table
	init_IDT();

	// exceptions
	init_exception();

	// Relocation of IRQ's
	remap_pics(0x20, 0x28);

	// Activate them

	// IDT table
	activate_IDT();

	// and allow interupts
	STI();

	// Kernel is now up and running

	// Our test code
	i=10;
	j=i/0;

	// infinite loop
	while(1){}
}