#include "..\BSOD System\BSOD.h"
#include "IDT.h"

// The ISR addresses, do not know for sure if this is a legel way to access them
void isr0();
void isr1();
void isr2();
void isr3();
void isr4();
void isr5();
void isr6();
void isr7();
void isr8();
void isr9();
void isr10();
void isr11();
void isr12();
void isr13();
void isr14();
void isr15();
void isr16();
void isr17();
void isr18();
void isr19();
void isr20();
void isr21();
void isr22();
void isr23();
void isr24();
void isr25();
void isr26();
void isr27();
void isr28();
void isr29();
void isr30();
void isr31();

// Our initialization code
// register all exception interupts
void init_exception()
{
	register_ISR(0, isr0);
	register_ISR(1, isr1);
	register_ISR(2, isr2);
	register_ISR(3, isr3);
	register_ISR(4, isr4);
	register_ISR(5, isr5);
	register_ISR(6, isr6);
	register_ISR(7, isr7);
	register_ISR(8, isr8);
	register_ISR(9, isr9);
	register_ISR(10, isr10);
	register_ISR(11, isr11);
	register_ISR(12, isr12);
	register_ISR(13, isr13);
	register_ISR(14, isr14);
	register_ISR(15, isr15);
	register_ISR(16, isr16);
	register_ISR(17, isr17);
	register_ISR(18, isr18);
	register_ISR(19, isr19);
	register_ISR(20, isr20);
	register_ISR(21, isr21);
	register_ISR(22, isr22);
	register_ISR(23, isr23);
	register_ISR(24, isr24);
	register_ISR(25, isr25);
	register_ISR(26, isr26);
	register_ISR(27, isr27);
	register_ISR(28, isr28);
	register_ISR(29, isr29);
	register_ISR(30, isr30);
	register_ISR(31, isr31);
}

// message array
char* messages[] = 
{
	"Division By Zero",
	"Debug",
	"Non Maskable Interrupt",
	"Breakpoint",
	"Into Detected Overflow",
	"Out of Bounds",
	"Invalid Opcode",
	"No Coprocessor",
	"Double Fault",
	"Coprocessor Segment Overrun",
	"Bad TSS",
	"Segment Not Present",
	"Stack Fault",
	"General Protection Fault",
	"Page Fault",
	"Unknown Interupt",
	"Coprocessor Fault",
	"Alignment Check",
	"Machine Check",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
	"reserverd",
};

void exception(int code, int arg)
{
	BSOD(messages[code]);
}