#include "..\shared\port.h"

#define PIC1 0x20
#define PIC2 0xA0

#define ICW1 0x11
#define ICW4 0x01

// remap our PIC's
void remap_pics(int pic1, int pic2)
{
	// Send ICW1
	out(PIC1, ICW1);
	out(PIC2, ICW1);

	// Send ICW2
	out(PIC1 + 1, pic1);
	out(PIC2 + 1, pic2);

	// Send ICW3
	out(PIC1 + 1, 4);
	out(PIC2 + 1, 2);

	// Send ICW4
	out(PIC1 + 1, ICW4);
	out(PIC2 + 1, ICW4);
}